﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ScheduleCRUDWithWebServices
{
    public partial class _Default : Page
    {
        localhost.WebService1 service = new localhost.WebService1();   // Creating the object to the service to call the method
        private string descriptionValue = null;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack) {
                BindAppointments();
            }
        }

        private void BindAppointments()
        {
            DataTable appointmentsData = default(DataTable);
            appointmentsData = service.BindAppointments();
            // Here we are calling the BindAppointments webservice method to read the data
            Schedule1.AppointmentSettings.DataSource = appointmentsData;
            //Here you need to pass the appointment value
        }

        private Dictionary<string, object> m_Arguments;
        public Dictionary<string, object> Arguments
        {
            get { return m_Arguments; }
            set { m_Arguments = value; }
        }

        protected void Schedule1_ServerAppointmentSaved(object sender, Syncfusion.JavaScript.Web.ScheduleEventArgs e)
        {
            Arguments = e.Arguments["appointment"] as Dictionary<string, object>;
            dynamic list = Arguments as Dictionary<string, object>;
            descriptionValue = list.ContainsKey("Description") == false ? "" : list["Description"].ToString();
            service.Insert(list["Id"], list["Subject"].ToString(), descriptionValue.ToString(), Convert.ToDateTime(list["StartTime"]).ToUniversalTime().ToString(), Convert.ToDateTime(list["EndTime"]).ToUniversalTime().ToString(), Convert.ToBoolean(list["AllDay"])); // Here we are calling the insert Web Service method 
            BindAppointments();
        }

        protected void Schedule1_ServerAppointmentEdited(object sender, Syncfusion.JavaScript.Web.ScheduleEventArgs e)
        {
            Arguments = e.Arguments["appointment"] as Dictionary<string, object>;
            dynamic list = Arguments as Dictionary<string, object>;
            descriptionValue = list.ContainsKey("Description") == false ? "" : list["Description"].ToString();
            service.Update(list["Id"], list["Subject"].ToString(), descriptionValue.ToString(), Convert.ToDateTime(list["StartTime"]).ToUniversalTime().ToString(), Convert.ToDateTime(list["EndTime"]).ToUniversalTime().ToString(), Convert.ToBoolean(list["AllDay"])); // Here we are calling the update Web Service method 
            BindAppointments();
        }

        protected void Schedule1_ServerAppointmentDeleted(object sender, Syncfusion.JavaScript.Web.ScheduleEventArgs e)
        {
            var Arguments1 = (System.Collections.ArrayList)e.Arguments["appointment"];
            var list = (Dictionary<String, Object>)Arguments1[0];
            service.Delete(Convert.ToInt32(list["Id"])); // Here we are calling the delete Web Service method 
            BindAppointments();
        }

        protected void Schedule1_ServerResizeStop(object sender, Syncfusion.JavaScript.Web.ScheduleEventArgs e)
        {
            Arguments = e.Arguments["appointment"] as Dictionary<string, object>;
            dynamic list = Arguments as Dictionary<string, object>;
            descriptionValue = list.ContainsKey("Description") == false ? "" : list["Description"].ToString();
            service.Update(list["Id"], list["Subject"].ToString(), descriptionValue.ToString(), Convert.ToDateTime(list["StartTime"]).ToUniversalTime().ToString(), Convert.ToDateTime(list["EndTime"]).ToUniversalTime().ToString(), Convert.ToBoolean(list["AllDay"])); // Here we are calling the update Web Service method 
            BindAppointments();
        }

        protected void Schedule1_ServerDragStop(object sender, Syncfusion.JavaScript.Web.ScheduleEventArgs e)
        {
            Arguments = e.Arguments["appointment"] as Dictionary<string, object>;
            dynamic list = Arguments as Dictionary<string, object>;
            descriptionValue = list.ContainsKey("Description") == false ? "" : list["Description"].ToString();
            service.Update(list["Id"], list["Subject"].ToString(), descriptionValue.ToString(), Convert.ToDateTime(list["StartTime"]).ToUniversalTime().ToString(), Convert.ToDateTime(list["EndTime"]).ToUniversalTime().ToString(), Convert.ToBoolean(list["AllDay"]));  // Here we are calling the update Web Service method 
            BindAppointments();
        }

    }
}